// Generated by LiveScript 1.4.0
var EventEmitter, HttpListener, ClientRegistry, CommandSender, ref$, delegate, delegateEvent, debug, ExoComm;
EventEmitter = require('events').EventEmitter;
HttpListener = require('./http-listener');
ClientRegistry = require('./client-registry');
CommandSender = require('./command-sender');
ref$ = require('rails-delegate'), delegate = ref$.delegate, delegateEvent = ref$.delegateEvent;
debug = require('debug')('exocomm');
ExoComm = (function(superclass){
  var prototype = extend$((import$(ExoComm, superclass).displayName = 'ExoComm', ExoComm), superclass).prototype, constructor = ExoComm;
  function ExoComm(){
    var x$;
    this.sendCommand = bind$(this, 'sendCommand', prototype);
    this.setServices = bind$(this, 'setServices', prototype);
    this.getConfig = bind$(this, 'getConfig', prototype);
    x$ = this.httpListener = new HttpListener;
    x$.on('set-services', this.setServices);
    x$.on('send-command', this.sendCommand);
    x$.on('get-config', this.getConfig);
    this.clientRegistry = new ClientRegistry;
    this.commandSender = new CommandSender;
    delegate('close', 'port', {
      from: this,
      to: this.httpListener
    });
    delegateEvent('listening', 'error', {
      from: this.httpListener,
      to: this
    });
  }
  prototype.getConfig = function(){
    return {
      services: this.clientRegistry.clients,
      routes: this.clientRegistry.routes
    };
  };
  prototype.listen = function(port){
    this.httpListener.listen(port);
    return debug("listening at port " + port);
  };
  prototype.setServices = function(serviceData){
    debug('receiving service data');
    this.emit('routing-setup');
    this.clientRegistry.setServices(serviceData);
    return 'success';
  };
  prototype.sendCommand = function(commandData){
    var subscribers, subscriberNames, res$, i$, len$, subscriber;
    subscribers = this.clientRegistry.subscribersTo(commandData.name);
    res$ = [];
    for (i$ = 0, len$ = subscribers.length; i$ < len$; ++i$) {
      subscriber = subscribers[i$];
      res$.push(subscriber.name);
    }
    subscriberNames = res$;
    debug("sending '" + commandData.name + "' to " + subscriberNames);
    this.commandSender.sendToServices(commandData, subscribers);
    this.emit('command', commandData.name, subscriberNames);
    return 'success';
  };
  return ExoComm;
}(EventEmitter));
module.exports = ExoComm;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}